# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator 2.3.33.0
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model


class AISuperComputerConfiguration(Model):
    """A class to manage AI Super Computer Configuration.

    :param instance_type: The class of compute to be used. The list of
     instance types is available in
     https://aiscaasdocs.azurewebsites.net/docs/instanceseries.md
    :type instance_type: str
    :param framework_image: The framework image to use. Supported values:
     PyTorch | Tensorflow".
    :type framework_image: str
    :param image_version: The image to use in AISC.  Currently only a limited
     set of predefined images are supported.
    :type image_version: str
    :param location: The location (region) where the job will run. The
     workspace region is used if not specified.
    :type location: str
    """

    _attribute_map = {
        'instance_type': {'key': 'instanceType', 'type': 'str'},
        'framework_image': {'key': 'frameworkImage', 'type': 'str'},
        'image_version': {'key': 'imageVersion', 'type': 'str'},
        'location': {'key': 'location', 'type': 'str'},
    }

    def __init__(self, instance_type=None, framework_image=None, image_version=None, location=None):
        super(AISuperComputerConfiguration, self).__init__()
        self.instance_type = instance_type
        self.framework_image = framework_image
        self.image_version = image_version
        self.location = location
