# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator 2.3.33.0
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model


class ArmTemplateDto(Model):
    """object used for creating workspace through calling arm template.

    :param workspace_name: Name of the workspace to deploy. Required
     parameter.
    :type workspace_name: str
    :param location: Location where the workspace should be deployed. Required
     parameter. Required parameter.
    :type location: str
    :param is_byo_storage: boolean parameter specifying if the workspace is
     going to associate with byo storage.
    :type is_byo_storage: bool
    :param byo_storage_arm_id: ArmId of storage account to associate with this
     workspace.
    :type byo_storage_arm_id: str
    :param storage_location: Location where the storage account lives. This is
     required when BYO storage is not in the same region as workspace.
    :type storage_location: str
    :param byo_acr_arm_id: ArmId of ACR to associate with this workspace.
    :type byo_acr_arm_id: str
    :param acr_location: Location where the container registry lives. This is
     required when BYO ACR is not in the same region as workspace.
    :type acr_location: str
    :param byo_key_vault_arm_id: ArmId of key vault to associate with this
     workspace.
    :type byo_key_vault_arm_id: str
    :param key_vault_location: Location where the key vault lives. This is
     required when BYO keyvault is not in the same region as workspace.
    :type key_vault_location: str
    :param byo_app_insight_arm_id: ArmId of application insight to associate
     with this workspace.
    :type byo_app_insight_arm_id: str
    :param app_insight_location: Location where the application insight lives.
     This is required when BYO application insight is not in the same region as
     workspace.
    :type app_insight_location: str
    :param is_byo_acr: boolean parameter specifying if the workspace is going
     to associate with byo acr.
    :type is_byo_acr: bool
    :param is_byo_key_vault: boolean parameter specifying if the workspace is
     going to associate with byo keyvault.
    :type is_byo_key_vault: bool
    :param is_byo_app_insights: boolean parameter specifying if the workspace
     is going to associate with byo appinsight.
    :type is_byo_app_insights: bool
    :param provision_storage_behind_private_endpoint: Should the storage
     account associated with this workspace have private endpoint.
    :type provision_storage_behind_private_endpoint: bool
    :param provision_storage_behind_service_endpoint: Should the storage
     account associated with this workspace have service endpoints.
    :type provision_storage_behind_service_endpoint: bool
    :param provision_key_vault_behind_private_endpoint: Should the keyvault
     associated with this workspace have private endpoints.
    :type provision_key_vault_behind_private_endpoint: bool
    :param provision_key_vault_behind_service_endpoint: Should the keyvault
     account associated with this workspace have service endpoint.
    :type provision_key_vault_behind_service_endpoint: bool
    :param cmk_keyvault_uri: If the workspace is enabled for CMK encryption,
     then this should point to the uri of the key for CMK encryption.
    :type cmk_keyvault_uri: str
    :param cmk_keyvault_arm_id: If the workspace is enabled for CMK
     encryption, then this should point to the keyvault armid of the keyvault
     holding the CMK key.
    :type cmk_keyvault_arm_id: str
    :param adb_workspace_arm_id: ArmId of adb workspace to associate with this
     workspace.
    :type adb_workspace_arm_id: str
    :param is_hbi_workspace: boolean parameter specifying if the workspace is
     high business impact workspace.
    :type is_hbi_workspace: bool
    :param sku: Sku of the workspace.
    :type sku: str
    :param auto_approve_private_endpoint: Should private endpoint be auto
     approved.
    :type auto_approve_private_endpoint: bool
    :param manual_approve_private_endpoint: Should private endpoint be
     manually approved.
    :type manual_approve_private_endpoint: bool
    :param properties: Configuration of the private endpoint attached with the
     workspace.
    :type properties: ~_restclient.models.WorkspacePrivateEndpointConfig
    :param compute_name: Name of MLC compute.
    :type compute_name: str
    :param compute_type: Type of MLC compute, such as AmlCompute,
     ComputeInstance, AKS, DSVM etc.
    :type compute_type: str
    :param aml_compute_admin_user_name: Admin User Name of the MLC compute.
    :type aml_compute_admin_user_name: str
    :param aml_compute_admin_user_password: Admin User Password of the MLC
     compute.
    :type aml_compute_admin_user_password: str
    :param aml_compute_vm_size: VM size of the MLC compute.
    :type aml_compute_vm_size: str
    :param aml_compute_min_node_count: Min node count of the MLC compute.
    :type aml_compute_min_node_count: int
    :param aml_compute_max_node_count: Max node count of the MLC compute.
    :type aml_compute_max_node_count: int
    :param compute_instance_vm_size: VM size of the compute instance.
    :type compute_instance_vm_size: str
    :param compute_instance_assigned_user_object_id: Assigned user object Id
     of the compute instance.
    :type compute_instance_assigned_user_object_id: str
    :param compute_instance_assigned_user_tenant_id: Assigned User Tenant Id
     of the compute instance.
    :type compute_instance_assigned_user_tenant_id: str
    :param attach_aks_cluster_arm_id: Arm resource Id of the attached AKS
     cluster.
    :type attach_aks_cluster_arm_id: str
    """

    _attribute_map = {
        'workspace_name': {'key': 'workspaceName', 'type': 'str'},
        'location': {'key': 'location', 'type': 'str'},
        'is_byo_storage': {'key': 'isByoStorage', 'type': 'bool'},
        'byo_storage_arm_id': {'key': 'byoStorageArmId', 'type': 'str'},
        'storage_location': {'key': 'storageLocation', 'type': 'str'},
        'byo_acr_arm_id': {'key': 'byoAcrArmId', 'type': 'str'},
        'acr_location': {'key': 'acrLocation', 'type': 'str'},
        'byo_key_vault_arm_id': {'key': 'byoKeyVaultArmId', 'type': 'str'},
        'key_vault_location': {'key': 'keyVaultLocation', 'type': 'str'},
        'byo_app_insight_arm_id': {'key': 'byoAppInsightArmId', 'type': 'str'},
        'app_insight_location': {'key': 'appInsightLocation', 'type': 'str'},
        'is_byo_acr': {'key': 'isByoAcr', 'type': 'bool'},
        'is_byo_key_vault': {'key': 'isByoKeyVault', 'type': 'bool'},
        'is_byo_app_insights': {'key': 'isByoAppInsights', 'type': 'bool'},
        'provision_storage_behind_private_endpoint': {'key': 'provisionStorageBehindPrivateEndpoint', 'type': 'bool'},
        'provision_storage_behind_service_endpoint': {'key': 'provisionStorageBehindServiceEndpoint', 'type': 'bool'},
        'provision_key_vault_behind_private_endpoint': {'key': 'provisionKeyVaultBehindPrivateEndpoint', 'type': 'bool'},
        'provision_key_vault_behind_service_endpoint': {'key': 'provisionKeyVaultBehindServiceEndpoint', 'type': 'bool'},
        'cmk_keyvault_uri': {'key': 'cmkKeyvaultUri', 'type': 'str'},
        'cmk_keyvault_arm_id': {'key': 'cmkKeyvaultArmId', 'type': 'str'},
        'adb_workspace_arm_id': {'key': 'adbWorkspaceArmId', 'type': 'str'},
        'is_hbi_workspace': {'key': 'isHbiWorkspace', 'type': 'bool'},
        'sku': {'key': 'sku', 'type': 'str'},
        'auto_approve_private_endpoint': {'key': 'autoApprovePrivateEndpoint', 'type': 'bool'},
        'manual_approve_private_endpoint': {'key': 'ManualApprovePrivateEndpoint', 'type': 'bool'},
        'properties': {'key': 'properties', 'type': 'WorkspacePrivateEndpointConfig'},
        'compute_name': {'key': 'ComputeName', 'type': 'str'},
        'compute_type': {'key': 'ComputeType', 'type': 'str'},
        'aml_compute_admin_user_name': {'key': 'AmlComputeAdminUserName', 'type': 'str'},
        'aml_compute_admin_user_password': {'key': 'AmlComputeAdminUserPassword', 'type': 'str'},
        'aml_compute_vm_size': {'key': 'AmlComputeVmSize', 'type': 'str'},
        'aml_compute_min_node_count': {'key': 'AmlComputeMinNodeCount', 'type': 'int'},
        'aml_compute_max_node_count': {'key': 'AmlComputeMaxNodeCount', 'type': 'int'},
        'compute_instance_vm_size': {'key': 'ComputeInstanceVmSize', 'type': 'str'},
        'compute_instance_assigned_user_object_id': {'key': 'ComputeInstanceAssignedUserObjectId', 'type': 'str'},
        'compute_instance_assigned_user_tenant_id': {'key': 'ComputeInstanceAssignedUserTenantId', 'type': 'str'},
        'attach_aks_cluster_arm_id': {'key': 'AttachAksClusterArmId', 'type': 'str'},
    }

    def __init__(self, workspace_name=None, location=None, is_byo_storage=None, byo_storage_arm_id=None, storage_location=None, byo_acr_arm_id=None, acr_location=None, byo_key_vault_arm_id=None, key_vault_location=None, byo_app_insight_arm_id=None, app_insight_location=None, is_byo_acr=None, is_byo_key_vault=None, is_byo_app_insights=None, provision_storage_behind_private_endpoint=None, provision_storage_behind_service_endpoint=None, provision_key_vault_behind_private_endpoint=None, provision_key_vault_behind_service_endpoint=None, cmk_keyvault_uri=None, cmk_keyvault_arm_id=None, adb_workspace_arm_id=None, is_hbi_workspace=None, sku=None, auto_approve_private_endpoint=None, manual_approve_private_endpoint=None, properties=None, compute_name=None, compute_type=None, aml_compute_admin_user_name=None, aml_compute_admin_user_password=None, aml_compute_vm_size=None, aml_compute_min_node_count=None, aml_compute_max_node_count=None, compute_instance_vm_size=None, compute_instance_assigned_user_object_id=None, compute_instance_assigned_user_tenant_id=None, attach_aks_cluster_arm_id=None):
        super(ArmTemplateDto, self).__init__()
        self.workspace_name = workspace_name
        self.location = location
        self.is_byo_storage = is_byo_storage
        self.byo_storage_arm_id = byo_storage_arm_id
        self.storage_location = storage_location
        self.byo_acr_arm_id = byo_acr_arm_id
        self.acr_location = acr_location
        self.byo_key_vault_arm_id = byo_key_vault_arm_id
        self.key_vault_location = key_vault_location
        self.byo_app_insight_arm_id = byo_app_insight_arm_id
        self.app_insight_location = app_insight_location
        self.is_byo_acr = is_byo_acr
        self.is_byo_key_vault = is_byo_key_vault
        self.is_byo_app_insights = is_byo_app_insights
        self.provision_storage_behind_private_endpoint = provision_storage_behind_private_endpoint
        self.provision_storage_behind_service_endpoint = provision_storage_behind_service_endpoint
        self.provision_key_vault_behind_private_endpoint = provision_key_vault_behind_private_endpoint
        self.provision_key_vault_behind_service_endpoint = provision_key_vault_behind_service_endpoint
        self.cmk_keyvault_uri = cmk_keyvault_uri
        self.cmk_keyvault_arm_id = cmk_keyvault_arm_id
        self.adb_workspace_arm_id = adb_workspace_arm_id
        self.is_hbi_workspace = is_hbi_workspace
        self.sku = sku
        self.auto_approve_private_endpoint = auto_approve_private_endpoint
        self.manual_approve_private_endpoint = manual_approve_private_endpoint
        self.properties = properties
        self.compute_name = compute_name
        self.compute_type = compute_type
        self.aml_compute_admin_user_name = aml_compute_admin_user_name
        self.aml_compute_admin_user_password = aml_compute_admin_user_password
        self.aml_compute_vm_size = aml_compute_vm_size
        self.aml_compute_min_node_count = aml_compute_min_node_count
        self.aml_compute_max_node_count = aml_compute_max_node_count
        self.compute_instance_vm_size = compute_instance_vm_size
        self.compute_instance_assigned_user_object_id = compute_instance_assigned_user_object_id
        self.compute_instance_assigned_user_tenant_id = compute_instance_assigned_user_tenant_id
        self.attach_aks_cluster_arm_id = attach_aks_cluster_arm_id
