# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator 2.3.33.0
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model


class DockerConfiguration(Model):
    """A class to specify the docker runtime properties for the Run.

    :param use_docker: Set true to perform this run inside a Docker container.
     Amlcompute linux clusters require that jobs running inside Docker
     containers. The backend will override the value to be true for Amlcompute
     linux clusters.
    :type use_docker: bool
    :param shared_volumes: Set false to disable AzureML's usage of the Docker
     shared volumes feature to work around bugs in certain versions of Docker
     for Windows.
    :type shared_volumes: bool
    :param arguments: Extra arguments to the Docker run command.
     The extra docker container options like --cpus=2, --memory=1024
    :type arguments: list[str]
    """

    _attribute_map = {
        'use_docker': {'key': 'useDocker', 'type': 'bool'},
        'shared_volumes': {'key': 'sharedVolumes', 'type': 'bool'},
        'arguments': {'key': 'arguments', 'type': '[str]'},
    }

    def __init__(self, use_docker=None, shared_volumes=None, arguments=None):
        super(DockerConfiguration, self).__init__()
        self.use_docker = use_docker
        self.shared_volumes = shared_volumes
        self.arguments = arguments
