# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator 2.3.33.0
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model
from msrest.exceptions import HttpOperationError


class ModelErrorResponse(Model):
    """The Model Management Service Error object.

    :param code: The error code.
    :type code: str
    :param status_code: The HTTP status code.
    :type status_code: int
    :param message: The error message.
    :type message: str
    :param details: An array of error detail objects.
    :type details: list[~_restclient.models.ErrorDetails]
    :param correlation: A dictionary of information used to correlate the
     failing request.
    :type correlation: dict[str, str]
    """

    _attribute_map = {
        'code': {'key': 'code', 'type': 'str'},
        'status_code': {'key': 'statusCode', 'type': 'int'},
        'message': {'key': 'message', 'type': 'str'},
        'details': {'key': 'details', 'type': '[ErrorDetails]'},
        'correlation': {'key': 'correlation', 'type': '{str}'},
    }

    def __init__(self, code=None, status_code=None, message=None, details=None, correlation=None):
        super(ModelErrorResponse, self).__init__()
        self.code = code
        self.status_code = status_code
        self.message = message
        self.details = details
        self.correlation = correlation


class ModelErrorResponseException(HttpOperationError):
    """Server responsed with exception of type: 'ModelErrorResponse'.

    :param deserialize: A deserializer
    :param response: Server response to be deserialized.
    """

    def __init__(self, deserialize, response, *args):

        super(ModelErrorResponseException, self).__init__(deserialize, response, 'ModelErrorResponse', *args)
