# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator 2.3.33.0
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model


class ModelOptimizationRequest(Model):
    """The model optimization request.

    :param compute_name: the AmlCompute name used to do model optimization
    :type compute_name: str
    :param environment: the optional environment which will be updated for
     deployment
    :type environment: ~_restclient.models.ModelOptimizationRequestEnvironment
    :param optimization_config: the optimization configuration
    :type optimization_config:
     ~_restclient.models.ModelOptimizationRequestOptimizationConfig
    """

    _validation = {
        'compute_name': {'required': True},
        'optimization_config': {'required': True},
    }

    _attribute_map = {
        'compute_name': {'key': 'computeName', 'type': 'str'},
        'environment': {'key': 'environment', 'type': 'ModelOptimizationRequestEnvironment'},
        'optimization_config': {'key': 'optimizationConfig', 'type': 'ModelOptimizationRequestOptimizationConfig'},
    }

    def __init__(self, compute_name, optimization_config, environment=None):
        super(ModelOptimizationRequest, self).__init__()
        self.compute_name = compute_name
        self.environment = environment
        self.optimization_config = optimization_config
