# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator 2.3.33.0
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model


class RunDefinition(Model):
    """A class to manage Run Definition. Run Definition encompass all the
    properties including Run Configuration required to create a Run.

    :param configuration: Fully specified configuration information for the
     run. Even when that information
     is contained in configuration files within the project folder, the client
     collapses
     it all and inlines it into the run definition when submitting a run.
    :type configuration: ~_restclient.models.RunConfiguration
    :param snapshot_id: Snapshots are user project folders that have been
     uploaded to the cloud for subsequent
     execution. This field is required when executing against cloud-based
     compute targets
     unless the run submission was against the API endpoint that takes a zipped
     project folder
     inline with the request.
    :type snapshot_id: str
    :param snapshots: The code snapshots that have been uploaded to the cloud
     for subsequent execution.
     At least one snapshot is required when executing against cloud-based
     compute targets
     unless the run submission was against the API endpoint that takes a zipped
     project folder
     inline with the request.
    :type snapshots: list[~_restclient.models.Snapshot]
    :param parent_run_id: Specifies that the run history entry for this
     execution should be scoped within
     an existing run as a child. Defaults to null, meaning the run has no
     parent.
     This is intended for first-party service integration, not third-party API
     users.
    :type parent_run_id: str
    :param run_type: Specifies the runsource property for this run. The
     default value is "experiment" if not specified.
    :type run_type: str
    """

    _attribute_map = {
        'configuration': {'key': 'configuration', 'type': 'RunConfiguration'},
        'snapshot_id': {'key': 'snapshotId', 'type': 'str'},
        'snapshots': {'key': 'snapshots', 'type': '[Snapshot]'},
        'parent_run_id': {'key': 'parentRunId', 'type': 'str'},
        'run_type': {'key': 'runType', 'type': 'str'},
    }

    def __init__(self, configuration=None, snapshot_id=None, snapshots=None, parent_run_id=None, run_type=None):
        super(RunDefinition, self).__init__()
        self.configuration = configuration
        self.snapshot_id = snapshot_id
        self.snapshots = snapshots
        self.parent_run_id = parent_run_id
        self.run_type = run_type
