# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator 2.3.33.0
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model


class TensorflowConfiguration(Model):
    """A class for managing distributed tensorflow parameters configuration for an
    Tensorflow job/experiment run.
    The class properties will takes effect only when the framework is set to
    TensorFlow, and the communicator to ParameterServer in Run Configuration.
    AmlCompute is the only supported compute for this configuration.

    :param worker_count: The number of workers.
    :type worker_count: int
    :param parameter_server_count: Number of parameter servers.
    :type parameter_server_count: int
    """

    _attribute_map = {
        'worker_count': {'key': 'workerCount', 'type': 'int'},
        'parameter_server_count': {'key': 'parameterServerCount', 'type': 'int'},
    }

    def __init__(self, worker_count=None, parameter_server_count=None):
        super(TensorflowConfiguration, self).__init__()
        self.worker_count = worker_count
        self.parameter_server_count = parameter_server_count
